# ground object template - used for most ground objects

import random
import pygame
from pygame.locals import *
import game, gfx
from basespriteobj import *

class GroundObj(Sprite):

    type = GROUND_OBJECT
    bombable = 1

    def __init__(self,name,image):
        Sprite.__init__(self)

        self.name = name
        self.image = image
        self.pointvalue = game.point_tbl[self.name]
        self.rect = self.image.get_rect()
        self.lastrect = self.rect
        self.x,self.y = list(self.rect.topleft)
        self.x = float(gfx.rect.right + 1)
        self.y = float(game.ground_height-self.rect.height)
        self.dx = float(-game.groundspeed)
        self.dy = 0.0
        self.collision_timer = game.collision_timer
        self.objective = 0
        self.exploding = 0

    def tick(self, speedadjust):
        self.x += self.dx * speedadjust
        if self.x < gfx.rect.left - self.rect.width:
            self.dead = 1
        self.rect.topleft = [self.x,self.y]



    

